; The name of the installer
Name "Audio Recording Interface"

; The file to write
OutFile "audiorecordinginterface-ver-arch-setup.exe"

; The default installation directory
InstallDir "$PROGRAMFILES\AudioRecordingInterface"

;ComponentText "Please choose the options you would like to install"

; The text to prompt the user to enter a directory
DirText "Choose install directory"

;--------------------------------

; The stuff to install
Section "" ;No components page, name is not important

; Set output path to the installation directory.
SetOutPath $INSTDIR

; Put file there
File "audiorecordinginterface.exe"
File "CHANGELOG.txt"
File "LICENSE.txt"
File "Microsoft.VC90.CRT.manifest"
File "msvcm90.dll"
File "msvcp90.dll"
File "msvcr90.dll"
File "QtCore4.dll"
File "QtGui4.dll"
File "QtMultimedia4.dll"
File "README.txt"

SetOutPath "$INSTDIR\sounds"
File "sounds\started_rec.wav"
File "sounds\stopped_rec.wav"

CreateDirectory "$SMPROGRAMS\Audio Recording Interface"
CreateShortCut "$SMPROGRAMS\Audio Recording Interface\Audio Recording Interface.lnk" "$INSTDIR\audiorecordinginterface.exe"
CreateShortCut "$SMPROGRAMS\Audio Recording Interface\Uninstall.lnk" "$INSTDIR\Uninstall.exe"

WriteUninstaller $INSTDIR\Uninstall.exe

; //////// CREATE REGISTRY KEYS FOR ADD/REMOVE PROGRAMS IN CONTROL PANEL /////////

WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Audio Recording Interface" \
	"DisplayName" \
	"Audio Recording Interface (remove only)"

WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Audio Recording Interface"  \
	"UninstallString" \
	"$INSTDIR\Uninstall.exe"
	
MessageBox MB_YESNO|MB_ICONQUESTION "Installation was successful. Start the program now?" \
	IDNO end_install

SetAutoClose true
Exec "$INSTDIR\audiorecordinginterface.exe"
	
	end_install:

SectionEnd ; end the section

; The uninstall section
Section "Uninstall"

MessageBox MB_YESNO|MB_ICONQUESTION "Are you sure you wish to remove?" \
    IDNO end_uninstall

Delete "$SMPROGRAMS\Audio Recording Interface\Audio Recording Interface.lnk"
Delete "$SMPROGRAMS\Audio Recording Interface\Uninstall.lnk" 
RMDir "$SMPROGRAMS\Audio Recording Interface"

Delete "$INSTDIR\sounds\started_rec.wav"
Delete "$INSTDIR\sounds\stopped_rec.wav"
Delete "$INSTDIR\audiorecordinginterface.exe"
Delete "$INSTDIR\CHANGELOG.txt"
Delete "$INSTDIR\LICENSE.txt"
Delete "$INSTDIR\Microsoft.VC90.CRT.manifest"
Delete "$INSTDIR\msvcm90.dll"
Delete "$INSTDIR\msvcp90.dll"
Delete "$INSTDIR\msvcr90.dll"
Delete "$INSTDIR\QtCore4.dll"
Delete "$INSTDIR\QtGui4.dll"
Delete "$INSTDIR\QtMultimedia4.dll"
Delete "$INSTDIR\README.txt"
Delete "$INSTDIR\Uninstall.exe"
RMDir "$INSTDIR\sounds"
RMDir "$INSTDIR"

MessageBox MB_YESNO|MB_ICONQUESTION "Do you also wish to remove user settings?" \
    IDNO skip_user_settings_remove

Delete "$APPDATA\audiorecordinginterface\audioreciface.ini"
RMDir "$APPDATA\audiorecordinginterface"
	
	skip_user_settings_remove:
; Now delete registry keys
DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Audio Recording Interface"
	end_uninstall:
SectionEnd 

