//------------------------------------------------------------------------------
// application.h
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __APPLICATION_H__
#define __APPLICATION_H__

#include <QApplication>

class KeyStateMonitor;
class KeyStateReader;
class Shortcut;
class ShortcutsMonitor;

#define gpApp (Application::instance())

class Application : public QApplication
{
	public:
		static Application* instance();

		Application(int& argc, char** argv);
		virtual ~Application();

		KeyStateMonitor* keyStateMonitor();
		KeyStateReader* keyStateReader();
		ShortcutsMonitor* shortcutsMonitor();

		/**
		 * @brief Registers Shortcut with built-in ShortcutsMonitor.
		 */
		void registerShortcut(Shortcut* pShortcut);

	private:
		static const int KEY_STATE_READ_INTERVAL_MS;

		KeyStateMonitor* pKeyStateMonitor;
		KeyStateReader* pKeyStateReader;
		ShortcutsMonitor* pShortcutsMonitor;
};

#endif
