//------------------------------------------------------------------------------
// audiodevformat.h
//
// Copyright (C) 2013 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef ARI_AUDIO_AUDIODEVFORMAT_H
#define ARI_AUDIO_AUDIODEVFORMAT_H

#include <QAudioDeviceInfo>
#include <QAudioFormat>

class AudioDevFormat
{
	public:
		AudioDevFormat()
		{
			bValid = false;
		}

		AudioDevFormat(const QAudioDeviceInfo& audioDev, const QAudioFormat& format)
		{
			bValid = true;
			audioDev_ = audioDev;
			format_ = format;
		}

		const QAudioDeviceInfo& audioDev() const
		{
			return audioDev_;
		}

		const QAudioFormat& format() const
		{
			return format_;
		}

		bool isValid() const
		{
			return bValid;
		}

	private:
		QAudioDeviceInfo audioDev_;
		QAudioFormat format_;
		bool bValid;
};

#endif
