//------------------------------------------------------------------------------
// audioerror.cpp
//
// Copyright (C) 2013 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "audioerror.h"

QString AudioError::toString(AudioErrorType errorType)
{
	switch (errorType)
	{
		case DeviceNotFound:
			return tr("Audio input device \"%1\" was not found in "
				"the Operating System.");
		case NoAudioDevices:
			return tr("Your Operating System doesn't support any audio input"
				" devices.");
		case NoDefaultDevice:
			return tr("Your Operating System doesn't have any default audio "
				"input device set.\n"
				"Please check the configuration page.");
		case OutputOpenFailure:
			return tr("Unable to open output stream.");
		case OperationAlreadyInProgress:
			return tr("Attempted operation is already in progress.");
		case NotSet:
			return tr("Recorder was not prepared properly.");
		default:
			return tr("Unknown audio error");
	}
}

QString AudioError::toString(int errorType)
{
	return toString((AudioErrorType) errorType);
}
