//------------------------------------------------------------------------------
// audiorecorder.h
//
// Copyright (C) 2013 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef ARI_AUDIO_AUDIORECORDER_H
#define ARI_AUDIO_AUDIORECORDER_H

#include <QAudio>
#include <QAudioFormat>
#include <QAudioInput>
#include <QObject>

class FilteredAudioInput;

class AudioRecorder : public QObject
{
	Q_OBJECT

	public:
		AudioRecorder();
		~AudioRecorder();

		bool isRecording() const;
		int lastError() const;
		const QAudioFormat& recordingFormat() const;
		qint64 recordingTimeMs() const;
		/**
		 * @brief Return 0 on success, or AudioError::AudioErrorType on fail.
		 */
		int startRecording(QIODevice* outputStream);
		void stopRecording();

	signals:
		void notify();
		void stateChanged(QAudio::State state);

	private:
		class PrivData;

		PrivData* d;

		FilteredAudioInput* setupAudioInput();

	private slots:
		void onAudioInputStateChange(QAudio::State state);
		void onInputReadyRead();
};

#endif
