//------------------------------------------------------------------------------
// wavheader.cpp
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "wavheader.h"

#include <QDataStream>
#include <QDebug>

WAVHeader::WAVHeader()
{
	size = (quint32)-1;
}

WAVHeader::~WAVHeader()
{
}

bool WAVHeader::isValid() const
{
	return size != (quint32)-1;
}

WAVHeader WAVHeader::readFromDevice(QIODevice& dev)
{
	// TODO Implement me.
	return WAVHeader();
	//WAVHeader header;
	//
	//// This will be used to calculate the total header size.
	//qint32 startingPos = dev.pos();
	//
	//QDataStream stream(&dev);
	//QByteArray byteBuffer;

	//char rawBuffer[32];

	//stream.readRawData(rawBuffer, 4);
	//byteBuffer = QByteArray(rawBuffer, 4);
	//if (byteBuffer != "RIFF")
	//{
	//	qDebug() << "Failed to read WAVE file: "
	//		<< "header doesn't begin with 'RIFF'.";
	//	return WAVHeader();
	//}
	//
	//stream >> header.size;
	//stream.readRawData(rawBuffer, 4);
	//byteBuffer = QByteArray(rawBuffer, 4);
	//if (byteBuffer != "WAVE")
	//{
	//	qDebug() << "Failed to read WAVE file: "
	//		<< "couldn't find 'WAVE' ID tag.";
	//	return WAVHeader();
	//}
	//
	//{
	//	// Format Chunk
	//	stream.readRawData(rawBuffer, 4);
	//	byteBuffer = QByteArray(rawBuffer, 4);
	//	if (byteBuffer != "fmt ")
	//	{
	//		qDebug() << "Failed to read WAVE file: "
	//			<< "couldn't find 'fmt ' ID tag.";
	//		return WAVHeader();
	//	}
	//	
	//	stream >> header.format.size;
	//	
	//	if (subchunkSize < MIN_SUBCHUNK_SIZE)
	//	{
	//		qDebug() << "Failed to read WAVE file: "
	//			<< "'fmt ' subchunk size must be at least " << MIN_SUBCHUNK_SIZE 
	//			<< ", but was: " << subchunkSize;
	//		return WAVHeader();
	//	}
	//	
	//	stream >> header.format.audioFormat;
	//	if (audioFormat != PCM_AUDIO_FORMAT)
	//	{
	//		qDebug() << "Failed to read WAVE file: "
	//			<< "not supported audio format: " << audioFormat;
	//		return WAVHeader();
	//	}
	//	
	//	stream >> header.format.numChannels;
	//	stream >> header.format.sampleRate;
	//	stream >> header.format.byteRate;
	//	stream >> header.format.blockAlign;
	//	stream >> header.format.bitsPerSample;
	//	stream >> header.format.extraParamSize;
	//	
	//	if (header.format.extraParamSize > 0)
	//	{
	//		int extraParamSize = header.format.extraParamSize;
	//		char* extraParamBuffer = new char[extraParamSize];
	//		stream.readRawData(extraParamBuffer, extraParamSize);
	//		
	//		header.format.extraParams = QByteArray(extraParamBuffer, extraParamSize);
	//	}
	//	// Skip the rest of unnecessary data.
	//	stream.skipRawData(subchunkSize - MIN_SUBCHUNK_SIZE);
	//}
	//
	//{
	//	// Data Chunk
	//	stream.readRawData(rawBuffer, 4);
	//	byteBuffer = QByteArray(rawBuffer, 4);
	//	if (byteBuffer != "data")
	//	{
	//		qDebug() << "Failed to read WAVE file: "
	//			<< "couldn't find 'data' ID tag.";
	//		return QAudioFormat();
	//	}
	//}
	//
	//// Restore the old position.
	//dev.seek(oldPos);
	//	
	//return header;
}

bool WAVHeader::writeToDevice(QIODevice& dev)
{
	QDataStream stream(&dev);
	
	stream.setByteOrder(QDataStream::LittleEndian);
	stream.writeRawData("RIFF", 4);
	stream << size;
	stream.writeRawData("WAVE", 4);
	
	{
		// Format Chunk
		// Size is calculated automatically, and the header information
		// is actually ignored here.
		const int SUBCHUNK_SIZE = 16;
		quint32 size = SUBCHUNK_SIZE;
		if (format.audioFormat != FormatChunk::FORMAT_PCM)
		{
			size += format.extraParams.size();
		}
	
		stream.writeRawData("fmt ", 4);
		stream << size;
		stream << format.audioFormat;
		stream << format.numChannels;
		stream << format.sampleRate;
		stream << format.byteRate;
		stream << format.blockAlign;
		stream << format.bitsPerSample;
		
		if (format.audioFormat != FormatChunk::FORMAT_PCM)
		{
			stream << (qint16)format.extraParams.size();
			stream.writeRawData(format.extraParams.constData(), format.extraParams.size());
		}
	}
	
	{
		// Data Chunk
		stream.writeRawData("data", 4);
		stream << data.size;
	}
	
	return true;
}
///////////////////////////////////////////////////////////////////////////////
WAVHeader::FormatChunk::FormatChunk()
{
	size = 0;
	audioFormat = 0;
	numChannels = 0;
	sampleRate = 0;
	byteRate = 0;
	blockAlign = 0;
	bitsPerSample = 0;
}
///////////////////////////////////////////////////////////////////////////////
WAVHeader::DataChunk::DataChunk()
{
	size = 0;
}