//------------------------------------------------------------------------------
// filteredaudioinput.h
//
// Copyright (C) 2013 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef ARI_AUDIO_FILTEREDAUDIOINPUT_H
#define ARI_AUDIO_FILTEREDAUDIOINPUT_H

#include <QAudioInput>
#include <QByteArray>
#include <QObject>

class AudioDevFormat;

class FilteredAudioInput : public QObject
{
	Q_OBJECT

	public:
		FilteredAudioInput();
		~FilteredAudioInput();

		const AudioDevFormat& devFormat() const;
		bool isRecording() const;
		bool isSetup() const;
		QByteArray readPending() const;
		int setup();
		int start();
		void stop();
		qint64 recordingTimeMs() const;

	signals:
		void notify();
		void readyRead();
		void stateChanged(QAudio::State state);

	private:
		class PrivData;

		PrivData* d;

		void createFilterPipeline();
		AudioDevFormat obtainAudioDevFormat() const;
		QAudioInput* setupAudioInput();
};

#endif
