//------------------------------------------------------------------------------
// filterfactory.cpp
//
// Copyright (C) 2013 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "filterfactory.h"

#include "audio/filters/amplifyfilter.h"

const QString FilterFactory::F_AMPLIFY = "Amplify";


QMap<QString, QString> FilterFactory::allFilterNames()
{
	QMap<QString, QString> map;
	map.insert(F_AMPLIFY, QObject::tr("Amplify"));
	return map;
}

AudioFilter* FilterFactory::construct(const QString& name, const FilterMetaData& metaData)
{
	QString fname = name.trimmed();
	if (fname == F_AMPLIFY)
	{
		return new AmplifyFilter(metaData);
	}
	return NULL;
}

