//------------------------------------------------------------------------------
// filterfactory.h
//
// Copyright (C) 2013 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef CPP_AUDIO_FILTERS_FILTERFACTORY_H
#define CPP_AUDIO_FILTERS_FILTERFACTORY_H

#include <QMap>
#include <QString>

class AudioFilter;
class FilterMetaData;

class FilterFactory
{
	public:
		// Using strings as filter indexes allows to store them in config
		// in a human-readable way, and won't cause problems such as enum
		// if one possible value of the enum is removed.
		static const QString F_AMPLIFY;

		/**
		 * @brief A map of 'codename' -> 'translatable name' association.
		 */
		static QMap<QString, QString> allFilterNames();
		static AudioFilter* construct(const QString& name, const FilterMetaData& metaData);
	private:
};

#endif
