//------------------------------------------------------------------------------
// filterpipeline.h
//
// Copyright (C) 2013 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef CPP_AUDIO_FILTERS_FILTERPIPELINE_H
#define CPP_AUDIO_FILTERS_FILTERPIPELINE_H

#include <QBuffer>
#include <QByteArray>
#include <QIODevice>

class AudioFilter;

class FilterPipeline : public QIODevice
{
	public:
		FilterPipeline();
		~FilterPipeline();

		void addFilter(AudioFilter* filter);
		bool open(QIODevice::OpenMode mode = QIODevice::ReadWrite);
		const QList<AudioFilter*>& filters() const;

		bool isSequential() const
		{
			return true;
		}

	protected:
		qint64 readData(char* data, qint64 maxSize);
		qint64 writeData(const char* data, qint64 maxSize);

	private:
		class PrivData;

		PrivData* d;

		void resetQBuffer(QBuffer& buffer,
			const QByteArray& data = QByteArray());
};

#endif
