//------------------------------------------------------------------------------
// audioinputconfig.h
//
// Copyright (C) 2011 - 2012 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __AUDIOINPUTCONFIG_H__
#define __AUDIOINPUTCONFIG_H__

#include "config/configsection.h"

#include <QAudioFormat>

class AudioInputConfig : public ConfigSection
{
	public:
		AudioInputConfig(Config* pConfig);

		bool isSetByteOrder() const;
		bool isSetChannelCount() const;
		bool isSetCodec() const;
		bool isSetDeviceName() const;
		bool isSetSampleRate() const;
		bool isSetSampleSize() const;
		bool isSetSampleType() const;
		
		QAudioFormat::Endian byteOrder() const;
		int channelCount() const;
		QString codec() const;
		QString deviceName() const;
		int sampleRate() const;
		int sampleSize() const;
		QAudioFormat::SampleType sampleType() const;
		
		void setByteOrder(QAudioFormat::Endian endian);
		void setChannelCount(int count);
		void setCodec(const QString& str);
		void setDeviceName(const QString& str);
		void setSampleRate(int sampleRate);
		void setSampleSize(int sampleSize);
		void setSampleType(QAudioFormat::SampleType sampleType);
};

#endif
