//------------------------------------------------------------------------------
// config.h
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <QSettings>
#include <QString>

#define gpConfig (Config::instance())

class Config
{
	public:
		static void deinit();
		static void init(const QString& filename);
	
		static Config* instance()
		{
			return pConfig;
		}
		
		bool isFirstRun() const
		{
			return bIsFirstRun;
		}
		
		QSettings& settings();		
		void synchronize();

	private:
		static Config* pConfig;
	
		bool bIsFirstRun;
		QSettings* pSettings;
	
		Config();
		~Config();
};

#endif