//------------------------------------------------------------------------------
// configsection.cpp
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "configsection.h"

ConfigSection::ConfigSection(Config* pConfig, const QString& name)
{
	this->pConfig = pConfig;
	this->sectionName = name.trimmed();
}

void ConfigSection::setValue(const QString& varName, const QVariant& value)
{
	pConfig->settings().setValue(var(varName), value);
}

QVariant ConfigSection::value(const QString& varName, const QVariant& defaultValue) const
{
	return pConfig->settings().value(var(varName), defaultValue);
}

QString ConfigSection::var(const QString& name) const
{
	if (!this->sectionName.isEmpty())
	{
		return this->sectionName + "/" + name;
	}
	else
	{
		return name;
	}
}
