//------------------------------------------------------------------------------
// shortcutsconfig.cpp
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "shortcutsconfig.h"

const QString SECTION_NAME = "Shortcuts";

const QString START_RECORD = "StartRecord";
const QString STOP_RECORD = "StopRecord";
const QString TOGGLE_RECORD = "ToggleRecord";

ShortcutsConfig::ShortcutsConfig(Config* pConfig)
: ConfigSection(pConfig, SECTION_NAME)
{
}

QString ShortcutsConfig::startRecord()
{
	return value(START_RECORD).toString();
}

QString ShortcutsConfig::stopRecord()
{
	return value(STOP_RECORD).toString();
}

QString ShortcutsConfig::toggleRecord()
{
	return value(TOGGLE_RECORD).toString();
}

void ShortcutsConfig::setStartRecord(const QString& str)
{
	setValue(START_RECORD, str);
}

void ShortcutsConfig::setStopRecord(const QString& str)
{
	setValue(STOP_RECORD, str);
}

void ShortcutsConfig::setToggleRecord(const QString& str)
{
	setValue(TOGGLE_RECORD, str);
}
