//------------------------------------------------------------------------------
// audiocfgtab.h
//
// Copyright (C) 2012 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __AUDIOCFGTAB_H__
#define __AUDIOCFGTAB_H__

#include "ui_audiocfgtab.h"

#include "gui/configtabs/configtab.h"
#include <QAudioDeviceInfo>

class AudioCfgTab : public ConfigTab, private Ui::AudioCfgTab
{
	Q_OBJECT

	public:
		AudioCfgTab(QWidget* pParent = NULL);
		
		QString name() const
		{
			return tr("Audio Input");
		}

		void loadConfig();
		void saveConfig();

		QString validate();

	private:
		QAudioDeviceInfo currentAudioDevice() const;
		QAudioFormat currentAudioFormat() const;
		void fillFormatComboBoxes();
		void fillComboBox(QComboBox* pComboBox, const QList<int>& values);
	
		void hideErrorLabels();

		void loadAudioInputDevices();
		
		/**
		 * @brief Selects specified audio device in the combo box.
		 *
		 * @return <code>true</code> if specified device was found
		 *         and selected.
		 */
		bool selectAudioInputDevice(const QString& name);
		void selectDefaultAudioInputDevice();
		void setAudioFormat(const QAudioFormat& format);
		void setupFormatParameters();
		
		
	private slots:
		void audioDeviceChanged(int index);
};

#endif
