//------------------------------------------------------------------------------
// configtab.cpp
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "configtab.h"

#include "gui/widgets/iconlabel.h"
#include <QPixmap>

ConfigTab::ConfigTab(QWidget* pParent)
: QWidget(pParent)
{
	bFirstShowDone = false;
}

void ConfigTab::showErrorLabel(IconLabel* pLabel, ErrorLabelType type, const QString& text)
{
	QString icon;
	switch (type)
	{
		case ErrorLabel:
			icon = ":/icons/error";
			break;
			
		case WarningLabel:
			icon = ":/icons/warning_triangle";
			break;
			
		default:
			icon = ":/icons/help";
			break;
	}
	
	pLabel->setPixmap(QPixmap(icon));
	pLabel->setText(text);
	pLabel->show();
}

void ConfigTab::tabSelected()
{
	if (!bFirstShowDone)
	{
		bFirstShowDone = true;
		tabSelectedFirstTime();
	}
}

void ConfigTab::tabSelectedFirstTime()
{
	loadConfig();
}
