//------------------------------------------------------------------------------
// filterscfgtab.h
//
// Copyright (C) 2013 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef ARI_GUI_CONFIGTABS_FILTERSCFGTAB_H
#define ARI_GUI_CONFIGTABS_FILTERSCFGTAB_H

#include <QListWidgetItem>
#include "ui_filterscfgtab.h"

#include "gui/configtabs/configtab.h"
#include "config/filtersconfig.h"

class FiltersCfgTab : public ConfigTab, private Ui::FiltersCfgTab
{
	Q_OBJECT

	public:
		FiltersCfgTab(QWidget* pParent = NULL);
		
		QString name() const
		{
			return tr("Filters");
		}

		void loadConfig();
		void saveConfig();

		QString validate();

	private:
		QStringList allActiveFiltersNames() const;
		QStringList selectedActiveFiltersNames() const;

		bool canEnableConfigureButton() const;
		void configureFilter(const QString& filterName);

	private slots:
		void applyConfigureButtonEnabledState();
		void configureDoubleClickedFilter(QListWidgetItem* item);
		void configureSelectedActiveFilter();
};

#endif
