//------------------------------------------------------------------------------
// notificationscfgtab.h
//
// Copyright (C) 2012 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __NOTIFICATIONSCFGTAB_H__
#define __NOTIFICATIONSCFGTAB_H__

#include "ui_notificationscfgtab.h"

#include "gui/configtabs/configtab.h"

class NotificationsCfgTab : public ConfigTab, private Ui::NotificationsCfgTab
{
	Q_OBJECT

	public:
		NotificationsCfgTab(QWidget* pParent = NULL);
		
		QString name() const
		{
			return tr("Notifications");
		}

		void loadConfig();
		void saveConfig();

		QString validate();

	private:
		void hideErrorLabels();

		void playSoundIfExistsOrDisplayError(const QString& path);
		QString showPickWavFileDialog(const QString& defaultPath);
		QString validateFilePath(const QString& path);

	private slots:
		
		void playStartedRecordingSound();
		void playStoppedRecordingSound();
		void showPickStartedRecordingPathDialog();
		void showPickStoppedRecordingPathDialog();
};

#endif
