//------------------------------------------------------------------------------
// trayicon.cpp
//
// Copyright (C) 2011 - 2012 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "trayicon.h"

#include <QIcon>

#include "config/generalconfig.h"
#include "gui/mainwindow.h"

TrayIcon::TrayIcon(MainWindow* pMainWindow)
: QSystemTrayIcon(pMainWindow)
{
	this->pMainWindow = pMainWindow;
	
	this->connect(this, 
		SIGNAL( activated(QSystemTrayIcon::ActivationReason) ),
		SLOT( trayIconActivated(QSystemTrayIcon::ActivationReason) ) );
	
	this->setIcon(QIcon(":/icons/tray_icon"));
}

TrayIcon::~TrayIcon()
{
	this->hide();
}

void TrayIcon::setIconNormal()
{
	this->setIcon(QIcon(":/icons/tray_icon"));
}

void TrayIcon::setIconRecording()
{
	this->setIcon(QIcon(":/icons/tray_icon_rec"));
}

void TrayIcon::trayIconActivated(QSystemTrayIcon::ActivationReason reason)
{
	if (reason == QSystemTrayIcon::Trigger)
	{
		// If window is not visible we need to bring it back.
		// If window is visible but not active we need to activate it.
		// If window is both visible and active we need to minimize it.
	
		if (pMainWindow->isMinimized() || !pMainWindow->isVisible())
		{
			pMainWindow->bringUp();
		}
		//else if (!pMainWindow->isActiveWindow())
		//{
		//	// This doesn't work properly
		//	pMainWindow->activateWindow();
		//}
		else
		{
			GeneralConfig cfg(gpConfig);
			if (cfg.isMinimizeToTrayIconEnabled())
			{
				pMainWindow->hide();
			}
			else
			{
				pMainWindow->showMinimized();
			}
		}
	}
}

