//------------------------------------------------------------------------------
// iconlabel.cpp
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "iconlabel.h"

IconLabel::IconLabel(QWidget* pParent)
: QWidget(pParent)
{
	lblIcon = new QLabel(this);
	lblIcon->setPixmap(QPixmap(":/icons/help"));
	lblIcon->setSizePolicy(QSizePolicy::Maximum, QSizePolicy::Preferred);
	
	lblText = new QLabel(this);
	lblText->setText("TextLabel");
	
	pLayout = new QHBoxLayout(this);
	pLayout->addWidget(lblIcon);
	pLayout->addWidget(lblText);
	pLayout->setContentsMargins(0, 0, 0, 0);

	this->setLayout(pLayout);
	this->setContentsMargins(0, 0, 0, 0);
}

const QPixmap* IconLabel::pixmap() const
{
	return lblIcon->pixmap();
}

QString IconLabel::text() const
{
	return lblText->text();
}

void IconLabel::setPixmap(const QPixmap& pixmap)
{
	lblIcon->setPixmap(pixmap);
}

void IconLabel::setText(const QString& str)
{
	lblText->setText(str);
}
