//------------------------------------------------------------------------------
// timelabel.h
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __TIMELABEL_H__
#define __TIMELABEL_H__

#include <QLabel>
#include <QTime>
#include <QTimer>

class TimeLabel : public QLabel
{
	Q_OBJECT

	public:
		TimeLabel(QWidget* pParent = NULL);
		
		void increase(qint64 msec);
		void setTime(qint64 msec);
		qint64 time() const;
		
	public slots:
		void startAutoplay();
		void startAutoplay(double speedFactor);
		void stopAutoplay();
				
	private:
		class PrivData
		{
			public:
				double autoplaySpeedFactor;
				QTimer autoplayTimer;
				qint64 time;
				QTime lastAutoplayTimestamp;
		};
		
		PrivData d;
		
		void updateDisplay();
		
	private slots:
		void autoplayIncrease();
};

#endif
