//------------------------------------------------------------------------------
// keyboardhook.h
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __KEYBOARDHOOK_H__
#define __KEYBOARDHOOK_H__

#include <QObject>

class KeyboardHook : public QObject
{
	Q_OBJECT

	public:
		static void destroyInstance()
		{
			if (pInstance != NULL)
			{
				delete pInstance;
				pInstance = NULL;
			}
		}
	
		static KeyboardHook* instance()
		{
			if (pInstance == NULL)
			{
				pInstance = new KeyboardHook();
			}
			
			return pInstance;
		}

		void emitKeyDownDetected()
		{
			emit keyDownDetected();
		}

		void emitKeyUpDetected()
		{
			emit keyUpDetected();
		}
		
		void install();
		void uninstall();

	signals:
		void keyDownDetected();
		void keyUpDetected();
	
	private:
		static KeyboardHook* pInstance;
		
		KeyboardHook();
		
		void installHookOsSpecific();
		void uninstallHookOsSpecific();
};

#endif