//------------------------------------------------------------------------------
// keydecoder.cpp
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "keydecoder.h"

#include "keyboard/keydecoder.h"
#include "keyboard/keyinfo.h"

#include <QDebug>
#include <QKeySequence>
#include <QStringList>

QList<KeyInfo::KeyId> KeyDecoder::parseSequence(const QString& sequence)
{
	QList<KeyInfo::KeyId> keys;
	QStringList keysCodeNames = sequence.split("+");
	foreach (const QString& keyCodeName, keysCodeNames)
	{
		keys << toKeyId(keyCodeName);
	}
	
	return keys;
}

QString KeyDecoder::toCodeName(KeyInfo::KeyId key)
{
	return KeyInfo::fromKeyId(key).codeName();
}

KeyInfo::KeyId KeyDecoder::toKeyId(const QString& codeName)
{
	return KeyInfo::fromCodeName(codeName).keyId();
}

QString KeyDecoder::toSequence(const QList<KeyInfo::KeyId>& keys)
{
	QStringList sequence;
	foreach (KeyInfo::KeyId key, keys)
	{
		sequence << toCodeName(key);
	}
	
	return sequence.join("+");
}
