//------------------------------------------------------------------------------
// keydecoder.h
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __KEYDECODER_H__
#define __KEYDECODER_H__

#include "keyboard/keyinfo.h"

#include <QList>
#include <QString>

/**
 * @brief Decodes key from string or string from key.
 */ 
class KeyDecoder
{
	public:	
		/**
		 * @brief Parses sequence like Ctrl+A+S
		 *
		 * Each key in the sequence is translated to KeyInfo and returned
		 * in the list in the order it appeared in the sequence.
		 */
		static QList<KeyInfo::KeyId> parseSequence(const QString& sequence);
	
		static QString toCodeName(KeyInfo::KeyId key);
		static KeyInfo::KeyId toKeyId(const QString& codeName);
		static QString toSequence(const QList<KeyInfo::KeyId>& keys);
};

#endif
