//------------------------------------------------------------------------------
// keystatereader.cpp
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "keystatereader.h"

// The following #includes should already implement OS specific safeguards.
#include "keyboard/windows/keystatereader_win.h"
#include "keyboard/x11/keystatereader_x11.h"

KeyStateReader* KeyStateReader::instantiateOsSpecificReader()
{
	#ifdef Q_WS_WIN
	return new KeyStateReader_Win();
	#elif defined Q_WS_X11
	return new KeyStateReader_X11();
	#else
	return NULL;
	#endif
}
