//------------------------------------------------------------------------------
// shortcut.cpp
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "shortcut.h"

#include <cassert>
#include <QDebug>

Shortcut::Shortcut()
{
	bEnabled = true;
}

Shortcut::Shortcut(const QList<KeyInfo::KeyId>& keys)
{
	keysList = keys;
}
		
bool Shortcut::areKeysFitting(const QList<KeyInfo::KeyId>& keys) const
{
	if (keysList.isEmpty())
	{
		return false;
	}

	if (keys.size() != keysList.size())
	{
		return false;
	}
	
	foreach (KeyInfo::KeyId key, keys)
	{
		if (!keysList.contains(key))
		{
			return false;
		}
	}
	
	return true;
}

void Shortcut::fireSignalIfKeysAreFitting(const QList<KeyInfo::KeyId>& keys)
{
	if (areKeysFitting(keys) && isEnabled())
	{
		emit shortcutFired();
	}
}

const QList<KeyInfo::KeyId>& Shortcut::keys() const
{
	return keysList;
}

void Shortcut::setKeys(const QList<KeyInfo::KeyId>& keys)
{
	keysList = keys;
}
		