//------------------------------------------------------------------------------
// shortcutsmonitor.h
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __SHORTCUTSMONITOR_H__
#define __SHORTCUTSMONITOR_H__

#include "keyboard/keyinfo.h"

#include <QMap>
#include <QTimer>
#include <QSet>

class KeyStateMonitor;
class Shortcut;

class ShortcutsMonitor : public QObject
{
	Q_OBJECT;

	public:
		ShortcutsMonitor(KeyStateMonitor* pKeyStateMonitor);
		
		bool isEnabled() const
		{
			return bEnabled;
		}
		
		void registerShortcut(Shortcut* pShortcut);
		
		void setEnabled(bool bEnabled)
		{
			this->bEnabled = bEnabled;
		}
		
		void unregisterShortcut(Shortcut* pShortcut);

	private:
		bool bEnabled;
		KeyStateMonitor* pKeyStateMonitor;
		QList< Shortcut* > shortcutsList;

	private slots:
		void fireShortcutsForKeys(const QList<KeyInfo::KeyId>& keys);
		void keyBatchStateChange(QMap<KeyInfo::KeyId, int> keyStates);
};

#endif
