//------------------------------------------------------------------------------
// keysdictionary_win.h
//
// Notes:
// WINDOWS ONLY!
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __KEYSDICTIONARY_WIN_H__
#define __KEYSDICTIONARY_WIN_H__

#include <Qt>
#ifdef Q_WS_WIN
#include <QMap>
#include <QSet>

#include "keyboard/keyinfo.h"

class KeysDictionary_Win
{
	public:
		static KeysDictionary_Win* get()
		{
			if (pInstance == NULL)
			{
				pInstance = new KeysDictionary_Win();
			}

			return pInstance;
		}

		QSet<KeyInfo::KeyId> allKnownQtKeys() const;
		KeyInfo::KeyId fromNative(int vkCode) const;

	private:
		static KeysDictionary_Win* pInstance;

		QMap<int, KeyInfo::KeyId> windowsKeys;

		KeysDictionary_Win();

		void initWindowsKeymap();
};
#endif

#endif
