//------------------------------------------------------------------------------
// keystatereader_win.cpp
//
// Notes:
// WINDOWS ONLY!
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "keystatereader_win.h"

#ifdef Q_WS_WIN
#include "keyboard/windows/keysdictionary_win.h"
#include "keyboard/keystatemonitor.h"
#include <Windows.h>
#include <QDebug>

const int KEYDOWN_MASK = 1 << (sizeof(SHORT) * 8 - 1);

QSet<KeyInfo::KeyId> KeyStateReader_Win::allKnownQtKeys()
{
	return KeysDictionary_Win::get()->allKnownQtKeys();
}

QMap<KeyInfo::KeyId, int> KeyStateReader_Win::getCurrentState()
{
	const int NUM_KEYS = 256;

	QMap<KeyInfo::KeyId, int> map;

	for (int i = 0; i < NUM_KEYS; ++i)
	{
		KeyInfo::KeyId key = KeysDictionary_Win::get()->fromNative(i);
		if (key != KeyInfo::UnknownKey)
		{
			SHORT winKeyState = GetAsyncKeyState(i);
			KeyStateMonitor::KeyState keyState;

			keyState = ((winKeyState & KEYDOWN_MASK) != 0)
				? KeyStateMonitor::Pressed
				: KeyStateMonitor::Depressed;

			map.insert(key, keyState);
		}
	}

	return map;
}
#endif
