//------------------------------------------------------------------------------
// keystatereader_win.h
//
// Notes:
// WINDOWS ONLY!
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __KEYSTATEREADER_WIN_H__
#define __KEYSTATEREADER_WIN_H__

#include <Qt>
#ifdef Q_WS_WIN

#include "keyboard/keystatereader.h"
#include <QMap>

/**
 * @brief Reads states of all keyboard keys and returns them in
 *        a Qt map.
 *
 * Keys are read using GetAsyncKeyState() WINAPI function and converted
 * to the internal keycodes. The state of the keys is an enum of
 * the KeyStateMonitor::KeyState type.
 */
class KeyStateReader_Win : public KeyStateReader
{
	public:
		/**
		 * @brief All Qt keys that can be extracted from this reader.
		 */
		QSet<KeyInfo::KeyId> allKnownQtKeys();

		/**
		 * @brief Gets current keyboard state and returns it in a QMap.
		 */
		QMap<KeyInfo::KeyId, int> getCurrentState();

	private:
};
#endif

#endif
