//------------------------------------------------------------------------------
// keysdictionary_x11.h
//
// Notes:
// X11 (Linux) ONLY!
//
// Copyright (C) 2012 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __KEYSDICTIONARY_X11_H__
#define __KEYSDICTIONARY_X11_H__

#include <Qt>
#ifdef Q_WS_X11
#include <QMap>
#include <QSet>

#include "keyboard/keyinfo.h"

class KeysDictionary_X11
{
	public:
		static KeysDictionary_X11* get()
		{
			if (pInstance == NULL)
			{
				pInstance = new KeysDictionary_X11();
			}

			return pInstance;
		}

		QSet<KeyInfo::KeyId> allKnownQtKeys() const;

		/**
		 * @brief The returned list is cached for optimization purposes.
		 */
		const QList<int>& allKnownNativeKeySyms() const;

		KeyInfo::KeyId fromNative(int vkCode) const;

	private:
		static KeysDictionary_X11* pInstance;

		QMap<int, KeyInfo::KeyId> nativeKeys;
		mutable QList<int> nativeKeysList;

		KeysDictionary_X11();

		void initKeymap();
};
#endif

#endif
