//------------------------------------------------------------------------------
// keystatereader_x11.h
//
// Notes:
// X11 (Linux) ONLY!
//
// Copyright (C) 2012 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#ifndef __KEYSTATEREADER_X11_H__
#define __KEYSTATEREADER_X11_H__

#include <Qt>
#ifdef Q_WS_X11

#include "keyboard/keystatereader.h"
#include <QMap>

/**
 * @brief Reads states of all keyboard keys and returns them in
 *        a Qt map.
 */
class KeyStateReader_X11 : public KeyStateReader
{
	public:
		/**
		 * @brief All Qt keys that can be extracted from this reader.
		 */
		QSet<KeyInfo::KeyId> allKnownQtKeys();

		/**
		 * @brief Gets current keyboard state and returns it in a QMap.
		 */
		QMap<KeyInfo::KeyId, int> getCurrentState();

	private:
};
#endif

#endif
