//------------------------------------------------------------------------------
// versioninfo.cpp
//
// Copyright (C) 2011 "Zalewa" <zalewapl@gmail.com>
//------------------------------------------------------------------------------
#include "versioninfo.h"

#include "versiondefs.h"

QString VersionInfo::appDataDirName()
{
	#ifdef Q_WS_WIN
	return "audiorecordinginterface";
	#else
	return ".audiorecordinginterface";
	#endif
}

QString	VersionInfo::fullName()
{
	return programName() + " " + versionRevision();
}

QString VersionInfo::mainConfigFileName()
{
	#ifdef NDEBUG
	// Release
	return "audioreciface";
	#else
	// Debug
	return "audioreciface_debug";
	#endif
}

QString VersionInfo::programName()
{
	return "Audio Recording Interface";
}

QString VersionInfo::revision()
{
	return "";
	//return SVN_REVISION_STRING;
}

int VersionInfo::revisionNumber()
{
	return 0;
	//return SVN_REVISION_NUMBER;
}

QString VersionInfo::version()
{
	return VERSION_STRING;
}

QString VersionInfo::versionRevision()
{
	QString strVersion = version();

	if (!revision().isEmpty())
	{
		strVersion += " - r" + revision();
	}
	
	return strVersion;
}

QString VersionInfo::yearSpan()
{
	return YEARSPAN_STRING;
}
